#include <hmg.ch>
#INCLUDE "hbclass.ch"
REQUEST HB_GT_WIN_DEFAULT
REQUEST HB_CODEPAGE_UTF8EX

Function classPrint()
Parameters windowname,gridname,repotitle,papers,orient,autoalign
LOCAL oExcel, oSheet1, oSheet2, nFont, theitem2 := "", hIni := Time(),hFin, laCelda := {}
	oExcel := WorkBook():New("sample.xlsx")

	oSheet1:= oExcel:WorkSheet("Grid_1")
	oSheet1:paperSize := iif(papers>0,papers,1) //9 // A4
	oSheet1:lLandscape := iif(orient=1,.t.,.f.) //.T.
	oSheet1:leftMargin := 0.5
	oSheet1:rightMargin := 0.5
	oSheet1:topMargin := 0.5
	oSheet1:bottomMargin := 0.5
	nNumFmt := oExcel:NewFormat("#,##0.000")
	nNumFmt1 := oExcel:NewFormat("#,##0.00")

	nFill1 := oExcel:NewFillPattern( 1, "FFEEEEEE", "FFFFFFCC" )
	nFill2 := oExcel:NewFillPattern( 1, "FFDDDDDD", "FFEEEEEE" )
	// NewFont( cFont, nFontSize, lBold, lItalic, lUnderline, lStrike, cRGB )
	nFont := oExcel:NewFont( "Tahoma", 16, .T., .F., .F., .F., "FFFF0000" )
	nBorder := oExcel:NewBorder( 1, 1, 1, 1, 0 )
	nStyle :=  oExcel:NewStyle( nFont, nBorder, nFill1, 2, 2 )
	letra := convertToTitle(getproperty(windowname,gridname,"ColumnCOUNT"))
	oSheet1:MergeCell("A1:" + letra + "1")

	laCelda := {}
	aadd(laCelda,{1,1})
	oSheet1:Cell(laCelda[1], repotitle, nStyle )
	For _i := 1 To getproperty(windowname,gridname,"ColumnCOUNT")
		theItem2 := getproperty(windowname,gridname,"Header",_i)
		laCelda := {}
		aadd(laCelda,{4,_i})
		oSheet1:Cell(laCelda[1], theitem2 )
    Next
	For i:=1 To getproperty(windowname,gridname,"ItemCount")
		For g:=1 To getproperty(windowname,gridname,"ColumnCOUNT")
			letra := convertToTitle(g)
			theItem2 := getProperty(windowname,gridname,'cellex',i,g)
			If Empty(theItem2)
				theItem2 := "NULL"
			EndIf 
			laCelda := {}
			aadd(laCelda,{i + 4,g})
			//MsgBox(AllTrim(Str(laCelda[1,1])) + "," + AllTrim(Str(laCelda[1,2])),theItem2)
			oSheet1:Cell(laCelda[1], theitem2 )
		Next
	Next
	oExcel:Save()
	hFin := Time()
	SetProperty('main','Title',"Tiempo impresion class" + AllTrim(ElapTime(hIni,hFin)))
Return Nil

*****************************************************************
*** 
*** https://helloacm.com/cc-coding-exercise-excel-sheet-column-number-and-title-conversion/
***
***			Convertida de C++ a Harbour
***			Por Jorge Benavides
***	Agregada el 01/08/2016
*****************************************************************
Function convertToTitle(n)
Local r := ""
	while (n >= 0)
		r := chr(65 + (n - 1) % 26) + r
		n := (n - 1) / 26
	End
	r := Right(r,len(r)-1)
Return r